<?php
/*
 * @version $Id: HEADER 1 2010-03-03 21:49 Tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin racks v1.1.0 - GLPI 0.78
// ----------------------------------------------------------------------
 */

function plugin_racks_install() {
   global $DB;
   
	include_once (GLPI_ROOT."/plugins/racks/inc/profile.class.php");
   
   $update=false;
	if (!TableExists("glpi_plugin_rack_profiles") && !TableExists("glpi_plugin_racks_profiles")) {
      
		$DB->runFile(GLPI_ROOT ."/plugins/racks/sql/empty-1.1.0.sql");
  
   } else if (TableExists("glpi_plugin_rack_content") && !FieldExists("glpi_plugin_rack_content","first_powersupply")) {
      
      $update=true;
		$DB->runFile(GLPI_ROOT ."/plugins/racks/sql/update-1.0.2.sql");
		$DB->runFile(GLPI_ROOT ."/plugins/racks/sql/update-1.1.0.sql");

	} else if (!TableExists("glpi_plugin_racks_profiles")) {
      
      $update=true;
		$DB->runFile(GLPI_ROOT ."/plugins/racks/sql/update-1.1.0.sql");

	}
   
   if ($update) {
   
      $query_="SELECT *
            FROM `glpi_plugin_racks_profiles` ";
      $result_=$DB->query($query_);
      if ($DB->numrows($result_)>0) {

         while ($data=$DB->fetch_array($result_)) {
            $query="UPDATE `glpi_plugin_racks_profiles`
                  SET `profiles_id` = '".$data["id"]."'
                  WHERE `id` = '".$data["id"]."';";
            $result=$DB->query($query);

         }
      }
      
      $query="ALTER TABLE `glpi_plugin_racks_profiles`
               DROP `name` ;";
      $result=$DB->query($query);
      
      Plugin::migrateItemType(
         array(4450=>'PluginRacksRack',4451=>'PluginRacksOther'),
         array("glpi_bookmarks", "glpi_bookmarks_users", "glpi_displaypreferences",
               "glpi_documents_items", "glpi_infocoms", "glpi_logs", "glpi_tickets"),
         array("glpi_plugin_racks_racks_items","glpi_plugin_racks_itemspecifications"));
	}
	
   PluginRacksProfile::createFirstAccess($_SESSION['glpiactiveprofile']['id']);
	return true;
}

function plugin_racks_uninstall() {
	global $DB;

	foreach (array (
			"glpi_plugin_racks_racks",
			"glpi_plugin_racks_racks_items",
			"glpi_plugin_racks_profiles",
			"glpi_plugin_racks_itemspecifications",
			"glpi_plugin_racks_rackmodels",
			"glpi_plugin_racks_roomlocations",
			"glpi_plugin_racks_connections",
			"glpi_plugin_racks_configs",
			"glpi_plugin_racks_others",
			"glpi_plugin_racks_othermodels"
		) as $table)
		$DB->query("DROP TABLE IF EXISTS `$table`;");
   
   //old versions	
   $tables = array("glpi_plugin_rack",
					"glpi_plugin_rack_content",
					"glpi_plugin_rack_device_spec",
					"glpi_plugin_rack_profiles",
					"glpi_plugin_rack_config",
					"glpi_dropdown_plugin_rack_room_locations",
					"glpi_dropdown_plugin_rack_ways",
					"glpi_plugin_rack_others",
					"glpi_dropdown_plugin_rack_others_type");

	foreach($tables as $table)
		$DB->query("DROP TABLE IF EXISTS `$table`;");
	
	$tables_glpi = array("glpi_displaypreferences",
					"glpi_documents_items",
					"glpi_bookmarks",
					"glpi_logs");
						
	foreach($tables_glpi as $table_glpi)
    $DB->query("DELETE FROM `$table_glpi` WHERE `itemtype` = 'PluginRacksRack';");

	return true;
}

// Define dropdown relations
function plugin_racks_getDatabaseRelations() {

	$plugin = new Plugin();
	if ($plugin->isActivated("racks"))
		return array("glpi_plugin_racks_roomlocations"=>array("glpi_plugin_racks_racks"=>"plugin_racks_roomlocations_id"),
               "glpi_plugin_racks_rackmodels"=>array("glpi_plugin_racks_racks"=>"plugin_racks_rackmodels_id"),
               "glpi_locations"=>array("glpi_plugin_racks_racks"=>"locations_id"),
               "glpi_users"=>array("glpi_plugin_racks_racks"=>"users_id"),
               "glpi_groups"=>array("glpi_plugin_racks_racks"=>"groups_id"),
               "glpi_manufacturers"=>array("glpi_plugin_racks_racks"=>"manufacturers_id"),
               "glpi_plugin_racks_racks"=>array("glpi_plugin_racks_racks_items"=>"plugin_racks_racks_id"),
               "glpi_plugin_racks_itemspecifications"=>array("glpi_plugin_racks_racks_items"=>"plugin_racks_itemspecifications_id"),
					 "glpi_plugin_racks_connections"=>array("glpi_plugin_racks_racks_items"=>"first_powersupply"),
					 "glpi_plugin_racks_connections"=>array("glpi_plugin_racks_racks_items"=>"second_powersupply"),
					 "glpi_plugin_racks_othermodels"=>array("glpi_plugin_racks_others"=>"plugin_racks_othermodels_id"),
					 "glpi_profiles" => array ("glpi_plugin_racks_profiles" => "profiles_id"),
					 "glpi_entities"=>array("glpi_plugin_racks_racks"=>"entities_id",
                                 "glpi_plugin_racks_roomlocations"=>"entities_id",
											"glpi_plugin_racks_others"=>"entities_id"));
	else
		return array();
}

// Define Dropdown tables to be manage in GLPI :
function plugin_racks_getDropdown() {
	global $LANG;
	
	$plugin = new Plugin();
	if ($plugin->isActivated("racks"))
		return array('PluginRacksRoomLocation'=>$LANG['plugin_racks'][11],
                  'PluginRacksRackModel'=>$LANG['plugin_racks'][12],
                 'PluginRacksConnection'=>$LANG['plugin_racks']['device'][1],
                 'PluginRacksOtherModel'=>$LANG['plugin_racks'][43]);
	else
		return array();
}

function plugin_racks_getAddSearchOptions($itemtype) {
	global $LANG;
    
   $sopt=array();
    
   if (in_array($itemtype, PluginRacksRack_Item::getClasses(true))) {
      if (plugin_racks_haveRight("racks", "r")) {
         $sopt[4460]['table'] = 'glpi_plugin_racks_racks';
         $sopt[4460]['field'] = 'name';
         $sopt[4460]['linkfield'] = '';
         $sopt[4460]['name'] = $LANG['plugin_racks']['title'][1] . " - " . $LANG['plugin_racks'][5];
         $sopt[4460]['forcegroupby']='1';
         $sopt[4460]['datatype']='itemlink';
         $sopt[4460]['itemlink_type']='PluginRacksRack';
      }
	}
	return $sopt;
}

//for search
function plugin_racks_addLeftJoin($type, $ref_table, $new_table, $linkfield, & $already_link_tables) {

	switch ($new_table) {
		case "glpi_plugin_racks_racks_items" :
			return " LEFT JOIN `$new_table` ON (`$ref_table`.`id` = `$new_table`.`plugin_racks_racks_id`) ";
			break;
		case "glpi_plugin_racks_racks" : // From items
			$out = " LEFT JOIN `glpi_plugin_racks_racks_items` ON (`$ref_table`.`id` = `glpi_plugin_racks_racks_items`.`items_id` AND `glpi_plugin_racks_racks_items`.`itemtype` = '$type') ";
			$out .= " LEFT JOIN `glpi_plugin_racks_racks` ON (`glpi_plugin_racks_racks`.`id` = `glpi_plugin_racks_racks_items`.`plugin_racks_racks_id`) ";
			return $out;
			break;
	}

	return "";
}

//force groupby for multible links to items
function plugin_racks_forceGroupBy($type) {

	return true;
	switch ($type) {
		case 'PluginRacksRack' :
			return true;
			break;

	}
	return false;
}

////// SPECIFIC MODIF MASSIVE FUNCTIONS ///////
function plugin_racks_MassiveActions($type) {

	global $LANG;
	switch ($type) {
		case 'PluginRacksRack' :
			return array (
				// Specific one
				"plugin_racks_transfert" => $LANG['buttons'][48],

			);
			break;
	}

	return array ();
}

function plugin_racks_MassiveActionsDisplay($options=array()) {
	global $LANG;
	
	switch ($options['itemtype']) {
		case 'PluginRacksRack' :
			switch ($options['action']) {

				case "plugin_racks_transfert" :
					Dropdown::show('Entity');
					echo "&nbsp;<input type=\"submit\" name=\"massiveaction\" class=\"submit\" value=\"" . $LANG['buttons'][2] . "\" >";
					break;
			}
			break;
	}

	return "";
}

function plugin_racks_MassiveActionsProcess($data) {

	switch ($data['action']) {

		case "plugin_racks_transfert" :
			if ($data['itemtype'] == 'PluginRacksRack') {
				foreach ($data["item"] as $key => $val) {
					if ($val == 1) {

						$PluginRacksRack = new PluginRacksRack;
						$values["id"] = $key;
						$values["entities_id"] = $data['entities_id'];
						$PluginRacksRack->update($values);
					}
				}
			}
			break;
	}
}

// Hook done on purge item case
function plugin_item_purge_racks($item) {
  
   $type = get_class($item);
   $temp = new PluginRacksRack_Item();
   $temp->deleteByCriteria(array('itemtype' => $type,
                                    'items_id' => $item->getField('id')));
   return true;

}

// Define headings added by the plugin
function plugin_get_headings_racks($item, $withtemplate) {
	global $LANG;
   
	if (get_class($item)=='Profile') {

		if ($item->getField('id') && $item->getField('interface')!='helpdesk') {
			return array(
				1 => $LANG['plugin_racks']['title'][1],
				);
		} else {
			return array();
		}
	} else if (in_array(get_class($item), PluginRacksRack_Item::getClasses(true))) {
		// template case
		if ($withtemplate) {
			return array();

		// Non template case
		} else  {
			return array(
				1 => $LANG['plugin_racks']['title'][1],
				);
		}
	} else if (in_array(get_class($item), PluginRacksItemSpecification::getModelClasses())) {
		// template case
		if ($item->getField('id')) {
			return array(
				1 => $LANG['plugin_racks'][50],
         );
		}
	}
	return false;

}

// Define headings actions added by the plugin
function plugin_headings_actions_racks($item) {
  
	if (in_array(get_class($item), PluginRacksRack_Item::getClasses(true))
      || in_array(get_class($item), PluginRacksItemSpecification::getModelClasses())
		|| (get_class($item)=='Profile' && $item->getField('interface')!='helpdesk')) {
		return array (
			1 => "plugin_headings_racks",

		);
	} else
		return false;

}

// action heading
function plugin_headings_racks($item,$withtemplate=0) {
	global $CFG_GLPI;
  
   $PluginRacksProfile=new PluginRacksProfile();
   $PluginRacksRack_Item=new PluginRacksRack_Item();
   $PluginRacksItemSpecification=new PluginRacksItemSpecification();
   
   switch (get_class($item)) {
      case 'Profile' :
         if (!$PluginRacksProfile->getFromDBByProfile($item->getField('id')))
            $PluginRacksProfile->createAccess($item->getField('id'));
         $PluginRacksProfile->showForm($item->getField('id'), array('target' => $CFG_GLPI["root_doc"]."/plugins/racks/front/profile.form.php"));
         break;
      default :
         if (in_array(get_class($item), PluginRacksRack_Item::getClasses(true))) {
            $PluginRacksRack_Item->showPluginFromItems(get_class($item),$item->getField('id'));
            $PluginRacksRack_Item->showform($CFG_GLPI["root_doc"]."/plugins/racks/front/rack_item.form.php",$item->getField('id'),get_class($item));
         } else if (in_array(get_class($item), PluginRacksItemSpecification::getModelClasses())) {
            $PluginRacksItemSpecification->showForm("", array('items_id' => $item->getField('id') ,'itemtype' => get_class($item), 'target' => $CFG_GLPI['root_doc']."/plugins/racks/front/itemspecification.form.php"));
         }
         break;
   }
}

?>