<?php
/*
 * @version $Id: HEADER 1 2010-03-03 21:49 Tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin racks v1.1.0 - GLPI 0.78
// ----------------------------------------------------------------------
 */

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

// Class for a Dropdown
class PluginRacksRoomLocation extends CommonTreeDropdown {
   
   static function getTypeName() {
      global $LANG;

      return $LANG['plugin_racks'][11];
   }
   
   static function getUsedNumber() {
      global $DB;
      
      $used = array();
      $query = "SELECT `plugin_racks_roomlocations_id`
                FROM `glpi_plugin_racks_racks`
                WHERE `plugin_racks_roomlocations_id` IS NOT NULL";
      $result = $DB->query($query);
      $number = $DB->numrows($result);
      if ($number>0) {
         while ($data= $DB->fetch_array($result)) {
            $used[]=$data["plugin_racks_roomlocations_id"];
         }
      }
      return $used;
   }
   
   function dropdownRoomLocations($name,$value,$entity) {

      $used = array();
      $used   = self::getUsedNumber();
      Dropdown::show('PluginRacksRoomLocation', array('name' => "plugin_racks_roomlocations_id",'value' => $value, 'entity' => $entity, 'used' => $used));
   
   }
   
   function canCreate() {
      return plugin_racks_haveRight('racks', 'w');
   }

   function canView() {
      return plugin_racks_haveRight('racks', 'r');
   } 
}

?>