<?php
/*
 * @version $Id: HEADER 1 2010-03-03 21:49 Tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin racks v1.1.0 - GLPI 0.78
// ----------------------------------------------------------------------
 */

function plugin_init_racks() {
	global $PLUGIN_HOOKS, $CFG_GLPI, $LANG,$PLUGIN_RACKS_MODEL_CLASS,$PLUGIN_RACKS_ITEM_MODELFIELD,$PLUGIN_RACKS_TYPE_CLASS;

	$PLUGIN_HOOKS['change_profile']['racks'] = array('PluginRacksProfile','changeProfile');
   if (class_exists('PluginRacksRack_Item')) { // only if plugin activated
      $PLUGIN_HOOKS['pre_item_purge']['racks'] = array('Profile'=>array('PluginRacksRack_Item', 'purgeProfiles'));

      $PLUGIN_HOOKS['item_purge']['racks'] = array();
      foreach (PluginRacksRack_Item::getClasses(true) as $type) {
         $PLUGIN_HOOKS['item_purge']['racks'][$type] = 'plugin_item_purge_racks';
      }
   }
   
	Plugin::registerClass('PluginRacksRack', array(
		'doc_types' => true
   ));
   
	if (getLoginUserID()) {

		// Display a menu entry ?
		if (plugin_racks_haveRight("racks", "r")) {
			$PLUGIN_HOOKS['menu_entry']['racks'] = 'front/rack.php';
			$PLUGIN_HOOKS['submenu_entry']['racks']['search'] = 'front/rack.php';
			$PLUGIN_HOOKS['headings']['racks'] = 'plugin_get_headings_racks';
			$PLUGIN_HOOKS['headings_action']['racks'] = 'plugin_headings_actions_racks';
			$PLUGIN_HOOKS['submenu_entry']['racks']['add'] = 'front/setup.templates.php?add=1';
		}

		if (plugin_racks_haveRight("model", "r")) {
			$PLUGIN_HOOKS['submenu_entry']['racks']['template'] = 'front/setup.templates.php?add=0';
			$PLUGIN_HOOKS['submenu_entry']['racks']["<img  src='".$CFG_GLPI["root_doc"]."/pics/menu_showall.png' title=\"".$LANG['plugin_racks']['setup'][12]."\" alt=\"".$LANG['plugin_racks']['setup'][12]."\">"] = 'front/itemspecification.php';
			
		}
			
		if (plugin_racks_haveRight("racks", "r"))  {
			$PLUGIN_HOOKS['submenu_entry']['racks']['config'] = 'front/config.form.php';
			$PLUGIN_HOOKS['use_massive_action']['racks'] = 1;
		}
		
		// Config page
		if (plugin_racks_haveRight("racks", "w") || haveRight("config", "w"))
			$PLUGIN_HOOKS['config_page']['racks'] = 'front/config.form.php';
			
		// Add specific files to add to the header : javascript or css
		//$PLUGIN_HOOKS['add_javascript']['example']="example.js";
		$PLUGIN_HOOKS['add_css']['racks'] = "racks.css";
	}
}

function plugin_version_racks() {
	global $LANG;

	return array (
		'name' => $LANG['plugin_racks']['title'][1],
		'version' => '1.1.0',
		'oldname' => 'rack',
		'author'=>'Philippe Béchu, Walid Nouh, Xavier Caillaud',
		'homepage'=>'https://forge.indepnet.net/projects/show/racks',
		'minGlpiVersion' => '0.78',// For compatibility / no install in version < 0.72
	);
}

// Optional : check prerequisites before install : may print errors or add to message after redirect
function plugin_racks_check_prerequisites() {
	if (GLPI_VERSION>=0.78) {
		return true;
	} else {
		echo "GLPI version not compatible need 0.78";
	}
}

// Uninstall process for plugin : need to return true if succeeded : may display messages or add to message after redirect
function plugin_racks_check_config() {
	return true;
}

function plugin_racks_haveRight($module,$right) {
	$matches=array(
			""  => array("","r","w"), // ne doit pas arriver normalement
			"r" => array("r","w"),
			"w" => array("w"),
			"1" => array("1"),
			"0" => array("0","1"), // ne doit pas arriver non plus
		      );
	if (isset($_SESSION["glpi_plugin_racks_profile"][$module])&&in_array($_SESSION["glpi_plugin_racks_profile"][$module],$matches[$right]))
		return true;
	else return false;
}

?>